<script src="https://cdnjs.cloudflare.com/ajax/libs/echarts/4.8.0/echarts-en.common.min.js" 
    integrity="sha512-/Q40jZijQiufYjvG6aiUq9PTUrOt/E9igis1ZLbZv89yl2FIsSwgeZr6w7WipE6ALQ5DuWME/BSCl9F0u0eunQ==" 
    crossorigin="anonymous"></script>

<script>
var chartScatterStudents =  echarts.init(document.getElementById('scatter-students'));
var data;
chartScatterStudents.on('click', function (params) {
   if (params && params.dataIndex && data && data.length) {
        var win = window.open('/analytics/score/student/' + data[params.dataIndex].id_student, '_blank');
        win.focus();
   }
});    
async function getScatterStudentsAnalytics(testId) {
    data = await $.get('/analytics/scatterstudents/' + testId);
    let min = 0, max = 100;
    if (data && data.length) {
        min = data[0].score;
        max = data[data.length - 1].score;
    }
    var option = {
        legend: {
            data: data.map(item => item.score)
        },
        title: {
            text: 'Score distribution (n = ' + data.length + ')',
            subtext: "Hover to see details, click to open student's profile in new tab"
        },
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                type: 'shadow'
            }
        },
        calculable: true,
        xAxis: {
            name: 'Score',
            nameLocation: 'center',
            nameGap: 25,
            type: 'category',
            data: data.map(item => item.score)
        },
        yAxis: {
            name: 'Score',
            nameGap: 25,
            nameLocation: 'center',
            nameRotate: 90,
            type: 'value'
        },
        tooltip: {
                padding: 5,
                borderWidth: 1,
                formatter: function (obj) {
                    var item = data[obj.dataIndex];                    
                    return item.img + item.full_name + '<br>Score: ' + item.score;
                }
            },
        series: [{
            data: data.map(item => ({
                value: item.score,
                itemStyle: {
                    color: edgar.getColorForPercentage(100 * (item.score-min) / (max-min) )
                }
            })),
            type: 'scatter',
            symbolSize: 6
        }]
    };
    chartScatterStudents.clear();
    chartScatterStudents.setOption(option);
}

var testsCombo = $("#scatter-test");
getScatterStudentsAnalytics(testsCombo.val());
testsCombo.on('change', function () {
    getScatterStudentsAnalytics(testsCombo.val());
});

</script>